#include "tg_common.glsl"

#ifdef _FRAGMENT_

vec4  GlowMapSelena(vec3 point, float height, float slope)
{
	// Thermal emission temperature (in thousand Kelvins)
    noiseOctaves = 5;
    vec3  p = point * 600.0 + Randomize;
    float dist = 10.0 * colorDistMagn * Fbm(p * 0.2);
    /*vec2 cell = Cell3Noise2(p + dist);
    //float varyTemp = 0.5 * smoothstep(0.0, 0.4, cell.y - cell.x);
    //float varyTemp = 0.5 * sqrt(abs(cell.y - cell.x));
    float varyTemp = 1.0 - 5.0 * smoothstep(0.1, 1.0, sqrt(abs(cell.y - cell.x)));
    float flow  = saturate(varyTemp * 0.2 * lavaCoverage);*/
    noiseOctaves = 3;
	float globTemp = 1.11 - abs(Fbm((p + dist) * 0.01)) * 0.08;
    noiseOctaves = 8;
	float varyTemp = abs(Fbm(p + dist));

	// Global surface melting
	float surfTemp = surfTemperature *
		(globTemp + varyTemp * 0.08) *
		saturate(2.0 * (lavaCoverage * 0.4 + 0.4 - 0.8 * height)) *
		saturate((lavaCoverage - 0.01) * 25.0);

    // Io-like volcanoes
    //float volcIo = saturate(abs(Fbm(point * 6.3 + Randomize) * 1.4)); // * 1.4 * volcActivity));
    //surfTemp = max(surfTemp, volcIo * (0.75 + 0.25 * varyTemp));

    // Shield volcano lava
    if (volcanoOctaves > 0)
    {
        // Global volcano activity mask
        noiseOctaves = 3;
        float volcActivity = saturate((Fbm(point * 1.37 + Randomize) - 1.0 + volcanoActivity) * 5.0);
        // Lava in the volcano caldera and lava flows
        noiseOctaves = 3;  // volcano roundness distortion
        craterRoundDist = 0.001;
		float volcTemp = VolcanoGlowNoise(point) * (0.75 + 0.25 * varyTemp) * volcActivity * volcanoTemp;
	    surfTemp = max(surfTemp, volcTemp);
    }

	//float r = log(surfTemp) * 0.188 + 0.1316;
	//return vec4(r, 0.0, 0.0, 1.0);

	vec4 outColor;
	outColor.rgb = UnitToColor24(log(surfTemp) * 0.11 + 0.14216);
	outColor.a = 1.0;
	return outColor;

	//vec4 outColor;
	//outColor.rgb = UnitToColor24(surfTemp * 0.1);
	//outColor.a = 1.0;
	//return outColor;
}

void main()
{
    vec3  point = GetSurfacePoint();
    float height, slope;
    GetSurfaceHeightAndSlope(height, slope);
    OutColor = GlowMapSelena(point, height, slope);
}

#endif
